'use strict';

var CurvaABCMedicaoItemController = angular.module('CurvaABCMedicaoItemController', []);

CurvaABCMedicaoItemController.controller('CurvaABCMedicaoItemCtrl', ['$scope', '$filter', 'Relatorio', 'Construcao', 'Material', 'CacheApp',
  ($scope, $filter, Relatorio, Construcao, Material, CacheApp) => {
    $scope.construcao = CacheApp.getConstrucao();

    $scope.getSelectedTipo = () => {
        return { Id: 0, Descricao: "Todos os Insumos" };
    }
    $scope.getSelectedMedicao = () => {
        return { Id: 0, Descricao: "Todas as Medições" };
    }
    $scope.selecionado = { Tipo: $scope.getSelectedTipo(), Medicao: $scope.getSelectedMedicao() };
    $scope.formulario = { Tipo: $scope.getSelectedTipo().Descricao, Medicao: $scope.getSelectedMedicao().Descricao, Etapa: 'Toads as Etapas', Composicao: 'Todas as Composições' };
    $scope.relatorio = { IdConstrucao: $scope.construcao.Id, Tipo: 0, Medicao: 0, IdEtapa: '0', IdComposicao: '0' };

    $scope.getRelatorioCurvaABCMedicaoItem = () => {
        $scope.curvaABC = [];
        Relatorio.getRelatorioCurvaABCMedicaoItem($scope.relatorio,
            (data) => {
                $scope.curvaABC = data.Instance;
            });
    }
    $scope.getRelatorioCurvaABCMedicaoItem();

    $scope.getTipoMaterial = () => {
        Material.getTipoMaterial(
            (data) => {
                $scope.listaTipoMaterial = data.Instance;
                $scope.listaTipoMaterial.unshift($scope.getSelectedTipo());
            });
    }
    $scope.getTipoMaterial();

    $scope.getMedicoes = () => {
        Relatorio.getMedicoes($scope.construcao.Id,
            (data) => {
                $scope.medicoes = data.Instance;
                $scope.medicoes.unshift($scope.getSelectedMedicao());
            });
    }
    $scope.getMedicoes();

    $scope.changeTipo = () => {
        $scope.formulario.Tipo = $scope.selecionado.Tipo.Descricao;
        $scope.relatorio.Tipo = $scope.selecionado.Tipo.Id;
        $scope.getRelatorioCurvaABCMedicaoItem();
    }

    $scope.changeMedicao = () => {
        $scope.formulario.Medicao = $scope.selecionado.Medicao.Descricao;
        $scope.relatorio.Medicao = $scope.selecionado.Medicao.Id;
        $scope.getRelatorioCurvaABCMedicaoItem();
    }

    $scope.changeComposicao = () => {
        $scope.formulario.Composicao = $scope.relatorio.IdComposicao == '0' ? 'Todas as Composições' : $scope.composicoes.filter(c => c.Id == $scope.relatorio.IdComposicao)[0].Nome;
        $scope.getRelatorioCurvaABCMedicaoItem();
    }

    $scope.pdfRelatorioCurvaABCMedicaoItem = () => {
        var cabecalho = {
            Avatar: $scope.construcao.ContaAvatar,
            Obra: $scope.construcao.Titulo,
            Conta: $scope.construcao.Conta + ' - ' + $scope.formulario.Medicao + ' - ' + $scope.formulario.Tipo + ' - ' + $scope.formulario.Etapa + ' - ' + $scope.formulario.Composicao,
            DataInicio: $filter("date")($scope.construcao.DataInicio, 'dd/MM/yyyy'),
            DataFim: $filter("date")($scope.construcao.DataFim, 'dd/MM/yyyy'),
            Moeda: $scope.construcao.Moeda
        };

        Relatorio.pdfRelatorioCurvaABCMedicaoItem($scope.relatorio, cabecalho,
            (data) => {
                window.location.assign(data.Instance);
            });
    }

    $scope.xlsRelatorioCurvaABCMedicaoItem = () => {
        var cabecalho = {
            Avatar: $scope.construcao.ContaAvatar,
            Obra: $scope.construcao.Titulo,
            Conta: $scope.construcao.Conta + ' - ' + $scope.formulario.Medicao + ' - ' + $scope.formulario.Tipo + ' - ' + $scope.formulario.Etapa + ' - ' + $scope.formulario.Composicao,
            DataInicio: $filter("date")($scope.construcao.DataInicio, 'dd/MM/yyyy'),
            DataFim: $filter("date")($scope.construcao.DataFim, 'dd/MM/yyyy'),
            Moeda: $scope.construcao.Moeda
        };

        Relatorio.xlsRelatorioCurvaABCMedicaoItem($scope.relatorio, cabecalho,
            (data) => {
                window.location.assign(data.Instance);
            }
        );
    }

    $scope.getEtapasConstrucao = () => {
        $scope.etapas = [];
        Construcao.getEtapasConstrucao($scope.construcao.Id,
            (data) => {
                $scope.etapas = data.Instance;
            });
    }
    $scope.getEtapasConstrucao();

    $scope.getListaComposicao = (IdEtapa) => {
        $scope.relatorio.IdComposicao = '0';
        $scope.formulario.Etapa = $scope.relatorio.IdEtapa == '0' ? 'Todas as Etapas' :
                                    $scope.etapas.filter(c => c.Id == $scope.relatorio.IdEtapa)[0].Descricao;

        $scope.getRelatorioCurvaABCMedicaoItem();
        Material.getListaMaterialAvanco(
            $scope.construcao.Id,
            IdEtapa,
            '',
            (data) => {
                $scope.composicoes = data.Instance;
            }
        );
    }
    
}]);
